API REST do Weblate¶
A API é acessível na URL /api/ e é baseada em framework Django REST. Você pode utilizá-la diretamente ou com o Weblate Client.
A API também é documentada usando OpenAPI 3.1 na URL /api/schema/, você pode navegar em /api/docs/.
Nota
O OpenAPI está disponível como uma prévia de recurso. A documentação provavelmente está incompleta neste momento e sujeita a alterações. Consulte a documentação abaixo para obter informações mais detalhadas sobre a API.
Autenticação e parâmetros genéricos¶
The read-only API is available without authentication unless
REQUIRE_LOGIN is turned on. Unauthenticated requests are heavily
throttled (by default to 100 requests per day), so it is recommended to use
authentication.
The authentication uses a token, which you can get in your profile. Use it in
the Authorization header:
- ANY /¶
Generic request behaviour for the API, the headers, status codes and parameters here apply to all endpoints as well.
- Query Parameters:
format – Response format (overrides Accept). Possible values depends on REST framework setup, by default
json,csvandapiare supported. The latter provides web browser interface for API.page – Returns given page of paginated results (use next and previous fields in response to automate the navigation).
page_size – Return the given number of items per request. The default is 50 and the maximum is 1000. For the units endpoints the default is 100 with a maximum of 10000. The default value is also configurable using the PAGE_SIZE setting.
- Request Headers:
Authorization – optional token to authenticate as
Authorization: Token YOUR-TOKEN
- Response Headers:
Content-Type – this depends on Accept header of request
Allow – list of allowed HTTP methods on object
- Response JSON Object:
detail (string) – verbose description of the result (for HTTP status codes other than 200 OK)
count (int) – total item count for object lists
next (string) – next page URL for object lists
previous (string) – previous page URL for object lists
results (array) – results for object lists
url (string) – URL to access this resource using the API
web_url (string) – URL to access this resource using web browser
- Status Codes:
200 OK – when request was correctly handled
201 Created – when a new object was created successfully
204 No Content – when an object was deleted successfully
400 Bad Request – when form parameters are missing
403 Forbidden – when access is denied
429 Too Many Requests – when throttling is in place
Tokens de autenticação¶
Alterado na versão 4.10: Tokens com escopo de projeto foram introduzidos na versão 4.10.
Cada usuário tem um token de acesso pessoal que pode ser obtido no perfil do usuário. Os tokens de usuário recém-gerados têm o prefixo wlu_.
É possível criar tokens com escopo de projeto para acesso à API apenas para determinado projeto. Esses tokens podem ser identificados pelo prefixo wlp_.
Exemplos de autenticação¶
Exemplo de solicitação:
GET /api/ HTTP/1.1
Host: example.com
Accept: application/json, text/javascript
Authorization: Token YOUR-TOKEN
Example response:
HTTP/1.0 200 OK
Date: Fri, 25 Mar 2016 09:46:12 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, HEAD, OPTIONS
{
"projects":"http://example.com/api/projects/",
"components":"http://example.com/api/components/",
"translations":"http://example.com/api/translations/",
"languages":"http://example.com/api/languages/"
}
Exemplo de CURL:
curl \
-H "Authorization: Token TOKEN" \
https://example.com/api/
Exemplos de passagem de parâmetros¶
Para o método POST os parâmetros podem ser especificados como envio de formulário (application/x-www-form-urlencoded) ou como JSON (application/json).
Exemplo de solicitação de formulário:
POST /api/projects/hello/repository/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/x-www-form-urlencoded
Authorization: Token TOKEN
operation=pull
Exemplo de solicitação JSON:
POST /api/projects/hello/repository/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20
{"operation":"pull"}
Exemplo de CURL:
curl \
-d operation=pull \
-H "Authorization: Token TOKEN" \
http://example.com/api/components/hello/weblate/repository/
Exemplo de CURL JSON:
curl \
--data-binary '{"operation":"pull"}' \
-H "Content-Type: application/json" \
-H "Authorization: Token TOKEN" \
http://example.com/api/components/hello/weblate/repository/
Componentes e categorias¶
Para acessar um componente aninhado em uma Categoria, é necessário codificar o nome da categoria no URL em um nome de componente separado por uma barra. Por exemplo, usage colocado em uma categoria docs precisa ser usado como docs%252Fusage. O URL completo nesse caso seria, por exemplo, https://example.com/api/components/hello/docs%252Fusage/repository/.
Limitação de taxa da API¶
As solicitações de API são limitadas; a configuração padrão limita-a a 100 solicitações por dia para usuários anônimos e 5000 solicitações por hora para usuários autenticados.
A limitação da taxa pode ser ajustada no settings.py. Consulte Throttling na documentação do framework Django REST para obter mais detalhes sobre como configurá-la.
No contêiner do Docker, isso pode ser configurado usando WEBLATE_API_RATELIMIT_ANON e WEBLATE_API_RATELIMIT_USER.
O status de limitação de taxa é relatado nos seguintes cabeçalhos:
|
Número permitido de solicitações para realizar |
|
Número restante de solicitações para realizar |
|
Quantidade total em segundos até que a janela limite de taxa seja reiniciada |
Alterado na versão 4.1: Adicionados cabeçalhos de status de limitação de taxa.
Respostas de erro¶
Alterado na versão 5.10: As respostas de erro eram específicas do endpoint antes desta versão.
As respostas de erro do Weblate são formatadas com base em Error Response Format.
Ponto de entrada da API¶
- GET /api/¶
The API root entry point.
Exemplo de solicitação:
GET /api/ HTTP/1.1 Host: example.com Accept: application/json, text/javascript Authorization: Token YOUR-TOKEN
Example response:
HTTP/1.0 200 OK Date: Fri, 25 Mar 2016 09:46:12 GMT Server: WSGIServer/0.1 Python/2.7.11+ Vary: Accept, Accept-Language, Cookie X-Frame-Options: SAMEORIGIN Content-Type: application/json Content-Language: en Allow: GET, HEAD, OPTIONS { "projects":"http://example.com/api/projects/", "components":"http://example.com/api/components/", "translations":"http://example.com/api/translations/", "languages":"http://example.com/api/languages/" }
Usuários¶
Adicionado na versão 4.0.
- GET /api/users/¶
Returns a list of users if you have permissions to see manage users. If not, then you get to see only your own details.
- Query Parameters:
username (string) – Username to search for
id (int) – User ID to search for
email (string) – Email to search for (case-insensitive, exact match). Requires
user.vieworuser.editpermission; the parameter is ignored for unprivileged users.
Ver também
Users object attributes are documented at
GET /api/users/(str:username)/.
- POST /api/users/¶
Creates a new user.
Requires the global
user.editpermission. See Controle de acesso for the user management permission model.- Parâmetros:
username (string) – Usuário
full_name (string) – User full name
email (string) – User email
is_superuser (boolean) – Is user superuser? (optional)
is_active (boolean) – Is user active? (optional)
is_bot (boolean) – Is user bot? (optional) (used for project scoped tokens)
- GET /api/users/(str: username)/¶
Returns information about users.
- Parâmetros:
username (string) – User’s username
- Response JSON Object:
username (string) – username of a user
full_name (string) – full name of a user
email (string) – email of a user
is_superuser (boolean) – whether the user is a super user
is_active (boolean) – whether the user is active
is_bot (boolean) – whether the user is bot (used for project scoped tokens)
date_joined (string) – date the user is created
last_login (string) – date the user last signed in
groups (array) – link to associated groups; see
GET /api/groups/(int:id)/languages (array) – link to translated languages; see
GET /api/languages/(string:language)/
Example JSON data:
{ "email": "user@example.com", "full_name": "Example User", "username": "exampleusername", "groups": [ "http://example.com/api/groups/2/", "http://example.com/api/groups/3/" ], "languages": [ "http://example.com/api/languages/cs/", ], "is_superuser": true, "is_active": true, "is_bot": false, "date_joined": "2020-03-29T18:42:42.617681Z", "url": "http://example.com/api/users/exampleusername/", "contributions_url": "http://example.com/api/users/exampleusername/contributions/" "statistics_url": "http://example.com/api/users/exampleusername/statistics/" }
- PUT /api/users/(str: username)/¶
Changes the user parameters.
Requires the global
user.editpermission unless a user is updating their own basic profile fields. See Controle de acesso for the user management permission model.- Parâmetros:
username (string) – User’s username
- Response JSON Object:
username (string) – username of a user
full_name (string) – full name of a user
email (string) – email of a user
is_superuser (boolean) – whether the user is a super user
is_active (boolean) – whether the user is active
is_bot (boolean) – whether the user is bot (used for project scoped tokens)
date_joined (string) – date the user is created
- PATCH /api/users/(str: username)/¶
Changes the user parameters.
Requires the global
user.editpermission unless a user is updating their own basic profile fields. See Controle de acesso for the user management permission model.- Parâmetros:
username (string) – User’s username
- Response JSON Object:
username (string) – username of a user
full_name (string) – full name of a user
email (string) – email of a user
is_superuser (boolean) – whether the user is a super user
is_active (boolean) – whether the user is active
is_bot (boolean) – whether the user is bot (used for project scoped tokens)
date_joined (string) – date the user is created
- DELETE /api/users/(str: username)/¶
Deletes all user information and marks the user inactive.
Requires the global
user.editpermission. See Controle de acesso for the user management permission model.- Parâmetros:
username (string) – User’s username
- POST /api/users/(str: username)/groups/¶
Associate groups with a user.
Requires the global
user.editpermission. See Controle de acesso for the user management permission model.- Parâmetros:
username (string) – User’s username
- Form Parameters:
string group_id – The unique group ID
- DELETE /api/users/(str: username)/groups/¶
Adicionado na versão 4.13.1.
Remove user from a group.
Requires the global
user.editpermission. See Controle de acesso for the user management permission model.- Parâmetros:
username (string) – User’s username
- Form Parameters:
string group_id – The unique group ID
- GET /api/users/(str: username)/statistics/¶
List statistics of a user.
- Parâmetros:
username (string) – User’s username
- Response JSON Object:
translated (int) – Number of translations by user
suggested (int) – Number of suggestions by user
uploaded (int) – Number of uploads by user
commented (int) – Number of comments by user
languages (int) – Number of languages user can translate
- GET /api/users/(str: username)/contributions/¶
List translations with contributions from a user.
- Parâmetros:
username (string) – User’s username
- Response JSON Object:
translations (array) – link to translations; see
GET /api/translations/(string:project)/(string:component)/(string:language)/
- GET /api/users/(str: username)/notifications/¶
List subscriptions of a user.
- Parâmetros:
username (string) – User’s username
- POST /api/users/(str: username)/notifications/¶
Associate subscriptions with a user.
- Parâmetros:
username (string) – User’s username
- Request JSON Object:
notification (string) – Name of notification registered
scope (int) – Scope of notification from the available choices
frequency (int) – Frequency choices for notifications
- GET /api/users/(str: username)/notifications/(int: subscription_id)/¶
Get a subscription associated with a user.
- Parâmetros:
username (string) – User’s username
subscription_id (int) – ID of notification registered
- PUT /api/users/(str: username)/notifications/(int: subscription_id)/¶
Edit a subscription associated with a user.
- Parâmetros:
username (string) – User’s username
subscription_id (int) – ID of notification registered
- Request JSON Object:
notification (string) – Name of notification registered
scope (int) – Scope of notification from the available choices
frequency (int) – Frequency choices for notifications
- PATCH /api/users/(str: username)/notifications/(int: subscription_id)/¶
Edit a subscription associated with a user.
- Parâmetros:
username (string) – User’s username
subscription_id (int) – ID of notification registered
- Request JSON Object:
notification (string) – Name of notification registered
scope (int) – Scope of notification from the available choices
frequency (int) – Frequency choices for notifications
- DELETE /api/users/(str: username)/notifications/(int: subscription_id)/¶
Delete a subscription associated with a user.
- Parâmetros:
username (string) – User’s username
subscription_id – Name of notification registered
subscription_id – int
Grupos¶
Adicionado na versão 4.0.
- GET /api/groups/¶
Returns a list of groups if you have permissions to see manage groups. If not, then you get to see only the groups the user is a part of.
Ver também
Group object attributes are documented at
GET /api/groups/(int:id)/.
- POST /api/groups/¶
Creates a new group.
- Parâmetros:
name (string) – Group name
project_selection (int) – Group of project selection from given options
language_selection (int) – Group of languages selected from given options
defining_project (str) – link to the defining project, used for Gerenciando controle de acesso por projeto; see
GET /api/projects/(string:project)/
- GET /api/groups/(int: id)/¶
Returns information about the group.
- Parâmetros:
id (int) – Group’s ID
- Response JSON Object:
name (string) – name of a group
project_selection (int) – integer corresponding to group of projects
language_selection (int) – integer corresponding to group of languages
roles (array) – link to associated roles; see
GET /api/roles/(int:id)/projects (array) – link to associated projects; see
GET /api/projects/(string:project)/components (array) – link to associated components; see
GET /api/components/(string:project)/(string:component)/componentlists (array) – link to associated componentlist; see
GET /api/component-lists/(str:slug)/defining_project (str) – link to the defining project, used for Gerenciando controle de acesso por projeto; see
GET /api/projects/(string:project)/admins (array) – link to associated administrators; see
GET /api/users/(str:username)/
Example JSON data:
{ "name": "Guests", "defining_project": null, "project_selection": 3, "language_selection": 1, "url": "http://example.com/api/groups/1/", "roles": [ "http://example.com/api/roles/1/", "http://example.com/api/roles/2/" ], "languages": [ "http://example.com/api/languages/en/", "http://example.com/api/languages/cs/", ], "projects": [ "http://example.com/api/projects/demo1/", "http://example.com/api/projects/demo/" ], "componentlist": "http://example.com/api/component-lists/new/", "components": [ "http://example.com/api/components/demo/weblate/" ], "admins": [ "http://example.com/api/users/exampleusername/" ] }
- PUT /api/groups/(int: id)/¶
Changes the group parameters.
- Parâmetros:
id (int) – Group’s ID
- Response JSON Object:
name (string) – name of a group
project_selection (int) – integer corresponding to group of projects
language_selection (int) – integer corresponding to group of languages
- PATCH /api/groups/(int: id)/¶
Changes the group parameters.
- Parâmetros:
id (int) – Group’s ID
- Response JSON Object:
name (string) – name of a group
project_selection (int) – integer corresponding to group of projects
language_selection (int) – integer corresponding to group of languages
- DELETE /api/groups/(int: id)/¶
Deletes the group.
- Parâmetros:
id (int) – Group’s ID
- POST /api/groups/(int: id)/roles/¶
Associate roles with a group.
- Parâmetros:
id (int) – Group’s ID
- Form Parameters:
string role_id – The unique role ID
- DELETE /api/groups/(int: id)/roles/(int: role_id)¶
Delete role from a group.
- Parâmetros:
id (int) – Group’s ID
role_id (int) – The unique role ID
- POST /api/groups/(int: id)/components/¶
Associate components with a group.
- Parâmetros:
id (int) – Group’s ID
- Form Parameters:
string component_id – The unique component ID
- DELETE /api/groups/(int: id)/components/(int: component_id)¶
Delete component from a group.
- Parâmetros:
id (int) – Group’s ID
component_id (int) – The unique component ID
- POST /api/groups/(int: id)/projects/¶
Associate projects with a group.
- Parâmetros:
id (int) – Group’s ID
- Form Parameters:
string project_id – The unique project ID
- DELETE /api/groups/(int: id)/projects/(int: project_id)¶
Delete project from a group.
- Parâmetros:
id (int) – Group’s ID
project_id (int) – The unique project ID
- POST /api/groups/(int: id)/languages/¶
Associate languages with a group.
- Parâmetros:
id (int) – Group’s ID
- Form Parameters:
string language_code – The unique language code
- DELETE /api/groups/(int: id)/languages/(string: language_code)¶
Delete language from a group.
- Parâmetros:
id (int) – Group’s ID
language_code (string) – The unique language code
- POST /api/groups/(int: id)/componentlists/¶
Associate componentlists with a group.
- Parâmetros:
id (int) – Group’s ID
- Form Parameters:
string component_list_id – The unique componentlist ID
- DELETE /api/groups/(int: id)/componentlists/(int: component_list_id)¶
Delete componentlist from a group.
- Parâmetros:
id (int) – Group’s ID
component_list_id (int) – The unique componentlist ID
- POST /api/groups/(int: id)/admins/¶
Adicionado na versão 5.5.
Add user to team admins.
- Parâmetros:
id (int) – Group’s ID
- Form Parameters:
string user_id – The user’s ID
- DELETE /api/groups/(int: id)/admins/(int: user_id)¶
Adicionado na versão 5.5.
Delete user from team admins.
- Parâmetros:
id (int) – Group’s ID
user_id (integer) – The user’s ID
Funções¶
- GET /api/roles/¶
Returns a list of all roles associated with user. If user is superuser, then list of all existing roles is returned.
Ver também
Roles object attributes are documented at
GET /api/roles/(int:id)/.
- POST /api/roles/¶
Creates a new role.
- Parâmetros:
name (string) – Role name
permissions (array) – List of codenames of permissions
- GET /api/roles/(int: id)/¶
Returns information about the role.
- Parâmetros:
id (int) – Role’s ID
- Response JSON Object:
name (string) – Role name
permissions (array) – list of codenames of permissions
Example JSON data:
{ "name": "Access repository", "permissions": [ "vcs.access", "vcs.view" ], "url": "http://example.com/api/roles/1/", }
- PUT /api/roles/(int: id)/¶
Changes the role parameters.
- Parâmetros:
id (int) – Role’s ID
- Response JSON Object:
name (string) – Role name
permissions (array) – list of codenames of permissions
- PATCH /api/roles/(int: id)/¶
Changes the role parameters.
- Parâmetros:
id (int) – Role’s ID
- Response JSON Object:
name (string) – Role name
permissions (array) – list of codenames of permissions
- DELETE /api/roles/(int: id)/¶
Deletes the role.
- Parâmetros:
id (int) – Role’s ID
Idiomas¶
- GET /api/languages/¶
Returns a list of all languages.
Ver também
Language object attributes are documented at
GET /api/languages/(string:language)/.
- POST /api/languages/¶
Creates a new language.
- Parâmetros:
code (string) – Nome do idioma
name (string) – Nome do idioma
direction (string) – Direção do texto
population (int) – Quantidade total de falantes
plural (object) – Language plural formula and number
- GET /api/languages/(string: language)/¶
Returns information about the language.
- Parâmetros:
language (string) – Código do idioma
- Response JSON Object:
code (string) – Código do idioma
direction (string) – Direção do texto
plural (object) – Object of language plural information
aliases (array) – Array of aliases for language
- Request JSON Object:
population (int) – Quantidade total de falantes
Example JSON data:
{ "code": "en", "direction": "ltr", "name": "English", "population": 159034349015, "plural": { "id": 75, "source": 0, "number": 2, "formula": "n != 1", "type": 1 }, "aliases": [ "english", "en_en", "base", "source", "eng" ], "url": "http://example.com/api/languages/en/", "web_url": "http://example.com/languages/en/", "statistics_url": "http://example.com/api/languages/en/statistics/" }
- PUT /api/languages/(string: language)/¶
Changes the language parameters.
- Parâmetros:
language (string) – Language’s code
- Request JSON Object:
name (string) – Nome do idioma
direction (string) – Direção do texto
population (int) – Quantidade total de falantes
plural (object) – Language plural details
- PATCH /api/languages/(string: language)/¶
Changes the language parameters.
- Parâmetros:
language (string) – Language’s code
- Request JSON Object:
name (string) – Nome do idioma
direction (string) – Direção do texto
population (int) – Quantidade total de falantes
plural (object) – Language plural details
- DELETE /api/languages/(string: language)/¶
Deletes the language.
- Parâmetros:
language (string) – Language’s code
- GET /api/languages/(string: language)/statistics/¶
Returns statistics for a language.
- Parâmetros:
language (string) – Código do idioma
Ver também
Returned attributes are described in Estatísticas.
Projetos¶
- GET /api/projects/¶
Returns a list of all projects.
Ver também
Project object attributes are documented at
GET /api/projects/(string:project)/.
- POST /api/projects/¶
Creates a new project.
- Parâmetros:
name (string) – Nome do projeto
slug (string) – Slug da URL do projeto
web (string) – Site do projeto
- GET /api/projects/(string: project)/¶
Returns information about the project.
- Parâmetros:
project (string) – Project URL slug
- Response JSON Object:
name (string) – project name
slug (string) – project slug
web (string) – project website
components_list_url (string) – URL to components list; see
GET /api/projects/(string:project)/components/repository_url (string) – URL to repository status; see
GET /api/projects/(string:project)/repository/changes_list_url (string) – URL to changes list; see
GET /api/projects/(string:project)/changes/credits_url (string) – URL to list contributor credits; see
GET /api/projects/(string:project)/credits/translation_review (boolean) – Habilitar revisões
source_review (boolean) – Habilitar revisões de fontes
enable_hooks (boolean) – Habilitar ganchos
instructions (string) – Instruções de tradução
language_aliases (string) – Aliases de idioma
announcements_url (string) – URL to announcements; see
GET /api/projects/(string:project)/announcements/
Example JSON data:
{ "name": "Hello", "slug": "hello", "url": "http://example.com/api/projects/hello/", "web": "https://weblate.org/", "web_url": "http://example.com/projects/hello/" }
- PATCH /api/projects/(string: project)/¶
Adicionado na versão 4.3.
Edit a project by a PATCH request.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
- PUT /api/projects/(string: project)/¶
Adicionado na versão 4.3.
Edit a project by a PUT request.
- Parâmetros:
project (string) – Project URL slug
- DELETE /api/projects/(string: project)/¶
Deletes a project.
- Parâmetros:
project (string) – Project URL slug
- GET /api/projects/(string: project)/changes/¶
Returns a list of project changes. This is essentially a project scoped
GET /api/changes/accepting same params.- Parâmetros:
project (string) – Project URL slug
- Response JSON Object:
results (array) – array of component objects; see
GET /api/changes/(int:id)/
- GET /api/projects/(string: project)/file/¶
Adicionado na versão 5.5.
Downloads all available translations associated with the project as an archive file using the requested format and language.
- Parâmetros:
project (string) – Project URL slug
- Query Parameters:
format (string) – The archive format to use; If not specified, defaults to
zip; Supported formats:zipandzip:CONVERSIONwhereCONVERSIONis one of converters listed at Baixando traduções.language_code (string) – The language code to download; If not specified, all languages are included.
- GET /api/projects/(string: project)/repository/¶
Returns information about the VCS repository status. This endpoint contains only an overall summary for all repositories for the project. To get more detailed status use
GET /api/components/(string:project)/(string:component)/repository/.- Parâmetros:
project (string) – Project URL slug
- Response JSON Object:
needs_commit (boolean) – whether there are any pending changes to commit
needs_merge (boolean) – whether there are any upstream changes to merge
needs_push (boolean) – whether there are any local changes to push
Example JSON data:
{ "needs_commit": true, "needs_merge": false, "needs_push": true }
- POST /api/projects/(string: project)/repository/¶
Performs given operation on the VCS repository.
- Parâmetros:
project (string) – Project URL slug
- Request JSON Object:
operation (string) – Operation to perform: one of
push,pull,commit,reset,cleanup,file-sync,file-scan
- Response JSON Object:
result (boolean) – result of the operation
Exemplo de CURL:
curl \ -d operation=pull \ -H "Authorization: Token TOKEN" \ http://example.com/api/projects/hello/repository/
Exemplo de solicitação JSON:
POST /api/projects/hello/repository/ HTTP/1.1 Host: example.com Accept: application/json Content-Type: application/json Authorization: Token TOKEN Content-Length: 20 {"operation":"pull"}
JSON response example:
HTTP/1.0 200 OK Date: Tue, 12 Apr 2016 09:32:50 GMT Server: WSGIServer/0.1 Python/2.7.11+ Vary: Accept, Accept-Language, Cookie X-Frame-Options: SAMEORIGIN Content-Type: application/json Content-Language: en Allow: GET, POST, HEAD, OPTIONS {"result":true}
- GET /api/projects/(string: project)/components/¶
Returns a list of translation components in the given project.
- Parâmetros:
project (string) – Project URL slug
- Response JSON Object:
results (array) – array of component objects; see
GET /api/components/(string:project)/(string:component)/
- POST /api/projects/(string: project)/components/¶
Alterado na versão 4.3: The
zipfileanddocfileparameters are now accepted for VCS-less components, see Arquivos locais.Alterado na versão 4.6: The cloned repositories are now automatically shared within a project using URLs internas do Weblate. Use
disable_autoshareto turn off this.Creates translation components in the given project.
Dica
Use URLs internas do Weblate when creating multiple components from a single VCS repository.
Nota
Most of the component creation happens in the background. Check the
task_urlattribute of created component and follow the progress there.- Parâmetros:
project (string) – Project URL slug
- Form Parameters:
file zipfile – ZIP file to upload into Weblate for translations initialization
file docfile – Document to translate
string from_component – Optional source component reference used to duplicate the new component. Accepts either a numeric component ID or a full Weblate component path. When provided, the new component inherits the source component configuration and translations into a new local repository. Repository fields such as
repo,vcs,branch,push, andpush_branchcan not be combined with this option.boolean disable_autoshare – Disables automatic repository sharing via URLs internas do Weblate.
- Request JSON Object:
object – Component parameters, see
GET /api/components/(string:project)/(string:component)/
- Response JSON Object:
result (object) – Created component object; see
GET /api/components/(string:project)/(string:component)/
JSON can not be used when uploading the files using the
zipfileanddocfileparameters. The data has to be uploaded as multipart/form-data.CURL form request example:
curl \ --form docfile=@strings.html \ --form name=Weblate \ --form slug=weblate \ --form file_format=html \ --form new_lang=add \ -H "Authorization: Token TOKEN" \ http://example.com/api/projects/hello/components/
CURL JSON request example:
curl \ --data-binary '{ "branch": "main", "file_format": "po", "file_format_params": { "po_line_wrap": 65535, "po_no_location": true }, "filemask": "po/*.po", "name": "Weblate", "slug": "weblate", "repo": "https://github.com/WeblateOrg/hello.git", "template": "", "new_base": "po/hello.pot", "vcs": "git" }' \ -H "Content-Type: application/json" \ -H "Authorization: Token TOKEN" \ http://example.com/api/projects/hello/components/
JSON request to create a new component from Git:
POST /api/projects/hello/components/ HTTP/1.1 Host: example.com Accept: application/json Content-Type: application/json Authorization: Token TOKEN Content-Length: 20 { "branch": "main", "file_format": "po", "file_format_params": { "po_line_wrap": 65535, "po_no_location": true }, "filemask": "po/*.po", "name": "Weblate", "slug": "weblate", "repo": "https://github.com/WeblateOrg/hello.git", "template": "", "new_base": "po/hello.pot", "vcs": "git" }
JSON request to create a new component from another one:
POST /api/projects/hello/components/ HTTP/1.1 Host: example.com Accept: application/json Content-Type: application/json Authorization: Token TOKEN Content-Length: 20 { "from_component": "hello/weblate", "name": "Weblate", "slug": "weblate" }
JSON response example:
HTTP/1.0 200 OK Date: Tue, 12 Apr 2016 09:32:50 GMT Server: WSGIServer/0.1 Python/2.7.11+ Vary: Accept, Accept-Language, Cookie X-Frame-Options: SAMEORIGIN Content-Type: application/json Content-Language: en Allow: GET, POST, HEAD, OPTIONS { "branch": "main", "file_format": "po", "file_format_params": { "po_line_wrap": 65535, "po_no_location": true }, "filemask": "po/*.po", "git_export": "", "license": "", "license_url": "", "name": "Weblate", "slug": "weblate", "project": { "name": "Hello", "slug": "hello", "source_language": { "code": "en", "direction": "ltr", "population": 159034349015, "name": "English", "url": "http://example.com/api/languages/en/", "web_url": "http://example.com/languages/en/" }, "url": "http://example.com/api/projects/hello/", "web": "https://weblate.org/", "web_url": "http://example.com/projects/hello/" }, "repo": "file:///home/nijel/work/weblate-hello", "template": "", "new_base": "", "url": "http://example.com/api/components/hello/weblate/", "vcs": "git", "web_url": "http://example.com/projects/hello/weblate/" }
- GET /api/projects/(string: project)/languages/¶
Returns paginated statistics for all languages within a project.
- Parâmetros:
project (string) – Project URL slug
- Response JSON Object:
results (array) – array of translation statistics objects
language (string) – language name
code (string) – language code
total (int) – total number of strings
translated (int) – number of translated strings
translated_percent (float) – percentage of translated strings
total_words (int) – total number of words
translated_words (int) – number of translated words
words_percent (float) – percentage of translated words
- GET /api/projects/(string: project)/statistics/¶
Returns statistics for a project.
- Parâmetros:
project (string) – Project URL slug
Ver também
Returned attributes are described in Estatísticas.
- GET /api/projects/(string: project)/categories/¶
Adicionado na versão 5.0: Returns categories for a project. See
GET /api/categories/(int:id)/for field definitions.- param project:
Project URL slug
- type project:
string
- GET /api/projects/(string: project)/labels/¶
Adicionado na versão 5.3: Returns labels for a project.
- param project:
Project URL slug
- type project:
string
- >json int id:
ID of the label
- >json string name:
name of the label
- >json string color:
color of the label
- POST /api/projects/(string: project)/labels/¶
Adicionado na versão 5.3: Creates a label for a project.
- param project:
Project URL slug
- type project:
string
- <json string name:
name of the label
- <json string color:
color of the label
- DELETE /api/projects/(string: project)/labels/(int: label_id)/¶
Adicionado na versão 5.14: Deletes a label from a project.
- param project:
Project URL slug
- type project:
string
- param label_id:
ID of the label to delete
- type label_id:
integer
- GET /api/projects/(string: project)/credits/¶
Returns contributor credits for a project.
Adicionado na versão 5.7.
- Parâmetros:
project (string) – Project URL slug
start (date) – Lower-bound ISO 8601 timestamp (mandatory)
end (date) – Upper-bound ISO 8601 timestamp (mandatory)
lang (source_language) – Language code to search for
- Response JSON Object:
email (string) – Email of the contributor
full_name (string) – Full name of the contributor
change_count (string) – Number of changes done in the time range
- GET /api/projects/(string: project)/machinery_settings/¶
Adicionado na versão 5.9.
Returns automatic suggestion settings for a project, consisting of the configurations defined for each translation service installed.
- Parâmetros:
project (string) – Project URL slug
- Response JSON Object:
suggestion_settings (object) – Configuration for all installed services.
- POST /api/projects/(string: project)/machinery_settings/¶
Adicionado na versão 5.9.
Create or update the service configuration for a project.
- Parâmetros:
project (string) – Project URL slug
- Form Parameters:
string service – Service name
string configuration – Service configuration in JSON
- GET /api/projects/(string: project)/languages/(string: language_code)/file/¶
Alterado na versão 5.15.1: Added ability to download ZIP file of all components translations in a project for 1 specific language.
Download a ZIP file of all translation files for a specified
language_codeacross all components for a givenprojectrather than downloading individual translated files and manually zipping them, with the archive named {project-slug}-{language-code}.zip and organized by component paths (e.g., component-slug/po/lang.po).- Parâmetros:
project (string) – Project URL slug
language_code (string) – Código do idioma
- Query Parameters:
filter (string) – Optional case-insensitive substring to filter components by slug (e.g.,
?filter=corewill match components with ‘core’ anywhere in their slug); only components whose slugs contain the substring will be included in the download.format (string) – The archive format to use; If not specified, defaults to
zip; Supported formats:zipandzip:CONVERSIONwhereCONVERSIONis one of converters listed at Baixando traduções.
Nota
Possible responses:
200 OKwith the ZIP file of translations for the specified language across all components in the project. If no components have translations for the specified language, an empty ZIP file will be returned.403 Forbiddenif the user does not have permission to the project.404 Not Foundif the project slug does not exist.
- GET /api/projects/(string: project)/announcements/¶
Adicionado na versão 5.17: Returns announcements for a project.
- param project:
Project URL slug
- type project:
string
- >json int id:
ID of the announcement
- >json string message:
announcement text
- >json string severity:
color of the message, one of
info(light blue),warning(yellow),danger(red),success(green)- >json date expiry:
hide after this date, ISO 8601 extended format date (optional)
- >json bool notify:
send notification to subscribed users? (optional)
- POST /api/projects/(string: project)/announcements/¶
Adicionado na versão 5.17: Creates an announcement for a project.
- param project:
Project URL slug
- type project:
string
- <json string message:
announcement text
- <json string severity:
color of the message, one of
info(light blue),warning(yellow),danger(red),success(green)- <json date expiry:
hide after this date, ISO 8601 extended format date (optional)
- <json bool notify:
send notification to subscribed users? (optional)
- DELETE /api/projects/(string: project)/announcements/(int: announcement_id)/¶
Adicionado na versão 5.17: Deletes an announcement from a project.
- param project:
Project URL slug
- type project:
string
- param announcement_id:
ID of the announcement to delete
- type announcement_id:
integer
Componentes¶
Dica
Usa POST /api/projects/(string:project)/components/ para criar novos componentes.
- GET /api/components/¶
Returns a list of translation components.
Ver também
Component object attributes are documented at
GET /api/components/(string:project)/(string:component)/.
- GET /api/components/(string: project)/(string: component)/¶
Returns information about the translation component.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
- Response JSON Object:
project (object) – the translation project; see
GET /api/projects/(string:project)/name (string) – Nome do componente
slug (string) – Slug do componente
vcs (string) – Sistema de controle de versão
linked_component (string) – component whose repository is linked via URLs internas do Weblate
repo (string) – Repositório do código-fonte, this is the actual repository URL even when URLs internas do Weblate are used, use
linked_componentto detect this situationgit_export (string) – URL do repositório exportado
branch (string) – Ramo do repositório, this is the actual repository branch even when URLs internas do Weblate are used
push (string) – URL de envio do repositório, this is the actual repository URL even when URLs internas do Weblate are used
push_branch (string) – Ramo do push, this is the actual repository branch even when URLs internas do Weblate are used
filemask (string) – Máscara do arquivo
template (string) – Arquivo de idioma da base monolíngue
edit_template (string) – Editar o arquivo base
intermediate (string) – Arquivo de idioma intermediário
new_base (string) – Modelo para novas traduções
file_format (string) – Formato de arquivo
file_format_params (object) – Parâmetros de formato de arquivo
license (string) – Licença da tradução
agreement (string) – Contrato de licença do colaborador
new_lang (string) – Adição de nova tradução
language_code_style (string) – Estilo de código de idioma
source_language (object) – source language object; see
GET /api/languages/(string:language)/check_flags (string) – Marcadores de tradução
priority (string) – Prioridade
enforced_checks (string) – Verificações forçadas
restricted (string) – Acesso restrito
repoweb (string) – Navegador do repositório
report_source_bugs (string) – Endereço do relatório de erros do texto fonte
merge_style (string) – Estilo de mesclagem
commit_message (string) – Mensagens de commit, add, merge, complemento e merge request
add_message (string) – Mensagens de commit, add, merge, complemento e merge request
delete_message (string) – Mensagens de commit, add, merge, complemento e merge request
merge_message (string) – Mensagens de commit, add, merge, complemento e merge request
addon_message (string) – Mensagens de commit, add, merge, complemento e merge request
pull_message (string) – Mensagens de commit, add, merge, complemento e merge request
allow_translation_propagation (string) – Permitir propagação de tradução
enable_suggestions (string) – Habilitar sugestões
suggestion_voting (string) – Votação de sugestões
suggestion_autoaccept (string) – Aceitar sugestões automaticamente
push_on_commit (boolean) – Enviar ao fazer commit; linked repositories expose the effective value from the linked component
locked (bool) – Whether component is locked, this field is read-only; see
GET /api/components/(string:project)/(string:component)/lock/commit_pending_age (integer) – Idade das alterações para fazer commit; linked repositories expose the effective value from the linked component
auto_lock_error (boolean) – Bloquear com erro; linked repositories expose the effective value from the linked component
language_regex (string) – Filtro de idioma
variant_regex (string) – Expressão regular de variantes
is_glossary (bool) – Usar como um glossário
glossary_color (string) – Cor do glossário
repository_url (string) – URL to repository status; see
GET /api/components/(string:project)/(string:component)/repository/translations_url (string) – URL to translations list; see
GET /api/components/(string:project)/(string:component)/translations/lock_url (string) – URL to lock status; see
GET /api/components/(string:project)/(string:component)/lock/changes_list_url (string) – URL to changes list; see
GET /api/components/(string:project)/(string:component)/changes/task_url (string) – URL to a background task (if any); see
GET /api/tasks/(str:uuid)/credits_url (string) – URL to list contributor credits; see
GET /api/components/(string:project)/(string:component)/credits/announcements_url (string) – URL to announcements; see
GET /api/components/(string:project)/(string:component)/announcements/
Example JSON data:
{ "branch": "main", "file_format": "po", "file_format_params": { "po_line_wrap": 65535, "po_no_location": true }, "filemask": "po/*.po", "git_export": "", "license": "", "license_url": "", "name": "Weblate", "slug": "weblate", "project": { "name": "Hello", "slug": "hello", "source_language": { "code": "en", "direction": "ltr", "population": 159034349015, "name": "English", "url": "http://example.com/api/languages/en/", "web_url": "http://example.com/languages/en/" }, "url": "http://example.com/api/projects/hello/", "web": "https://weblate.org/", "web_url": "http://example.com/projects/hello/" }, "source_language": { "code": "en", "direction": "ltr", "population": 159034349015, "name": "English", "url": "http://example.com/api/languages/en/", "web_url": "http://example.com/languages/en/" }, "repo": "file:///home/nijel/work/weblate-hello", "template": "", "new_base": "", "url": "http://example.com/api/components/hello/weblate/", "vcs": "git", "web_url": "http://example.com/projects/hello/weblate/" }
- PATCH /api/components/(string: project)/(string: component)/¶
Edit a component by a PATCH request.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
source_language (string) – Project source language code (optional)
- Request JSON Object:
name (string) – name of component
slug (string) – slug of component
repo (string) – VCS repository URL
Exemplo de CURL:
curl \ --data-binary '{"name": "new name"}' \ -H "Content-Type: application/json" \ -H "Authorization: Token TOKEN" \ PATCH http://example.com/api/projects/hello/components/
Exemplo de solicitação JSON:
PATCH /api/projects/hello/components/ HTTP/1.1 Host: example.com Accept: application/json Content-Type: application/json Authorization: Token TOKEN Content-Length: 20 { "name": "new name" }
JSON response example:
HTTP/1.0 200 OK Date: Tue, 12 Apr 2016 09:32:50 GMT Server: WSGIServer/0.1 Python/2.7.11+ Vary: Accept, Accept-Language, Cookie X-Frame-Options: SAMEORIGIN Content-Type: application/json Content-Language: en Allow: GET, POST, HEAD, OPTIONS { "branch": "main", "file_format": "po", "file_format_params": { "po_line_wrap": 65535, "po_no_location": true }, "filemask": "po/*.po", "git_export": "", "license": "", "license_url": "", "name": "new name", "slug": "weblate", "project": { "name": "Hello", "slug": "hello", "source_language": { "code": "en", "direction": "ltr", "population": 159034349015, "name": "English", "url": "http://example.com/api/languages/en/", "web_url": "http://example.com/languages/en/" }, "url": "http://example.com/api/projects/hello/", "web": "https://weblate.org/", "web_url": "http://example.com/projects/hello/" }, "repo": "file:///home/nijel/work/weblate-hello", "template": "", "new_base": "", "url": "http://example.com/api/components/hello/weblate/", "vcs": "git", "web_url": "http://example.com/projects/hello/weblate/" }
- PUT /api/components/(string: project)/(string: component)/¶
Edit a component by a PUT request.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
- Request JSON Object:
branch (string) – VCS repository branch
file_format (string) – file format of translations
file_format_params (object) – parameters related to the file
filemask (string) – mask of translation files in the repository
name (string) – name of component
slug (string) – slug of component
repo (string) – VCS repository URL
template (string) – base file for monolingual translations
new_base (string) – base file for adding new translations
vcs (string) – version control system
- DELETE /api/components/(string: project)/(string: component)/¶
Deletes a component.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
- GET /api/components/(string: project)/(string: component)/changes/¶
Returns a list of component changes. This is essentially a component scoped
GET /api/changes/accepting same params.- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
- Response JSON Object:
results (array) – array of component objects; see
GET /api/changes/(int:id)/
- GET /api/components/(string: project)/(string: component)/file/¶
Adicionado na versão 4.9.
Downloads all available translations associated with the component as an archive file using the requested format.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
- Query Parameters:
format (string) – The archive format to use; If not specified, defaults to
zip; Supported formats:zipandzip:CONVERSIONwhereCONVERSIONis one of converters listed at Baixando traduções.
- GET /api/components/(string: project)/(string: component)/screenshots/¶
Returns a list of component screenshots.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
- Response JSON Object:
results (array) – array of component screenshots; see
GET /api/screenshots/(int:id)/
- GET /api/components/(string: project)/(string: component)/lock/¶
Returns component lock status.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
- Response JSON Object:
locked (boolean) – whether component is locked for updates
Example JSON data:
{ "locked": false }
- POST /api/components/(string: project)/(string: component)/lock/¶
Sets component lock status.
Response is same as
GET /api/components/(string:project)/(string:component)/lock/.- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
- Request JSON Object:
lock – Boolean whether to lock or not.
Exemplo de CURL:
curl \ -d lock=true \ -H "Authorization: Token TOKEN" \ http://example.com/api/components/hello/weblate/repository/
Exemplo de solicitação JSON:
POST /api/components/hello/weblate/repository/ HTTP/1.1 Host: example.com Accept: application/json Content-Type: application/json Authorization: Token TOKEN Content-Length: 20 {"lock": true}
JSON response example:
HTTP/1.0 200 OK Date: Tue, 12 Apr 2016 09:32:50 GMT Server: WSGIServer/0.1 Python/2.7.11+ Vary: Accept, Accept-Language, Cookie X-Frame-Options: SAMEORIGIN Content-Type: application/json Content-Language: en Allow: GET, POST, HEAD, OPTIONS {"locked":true}
- GET /api/components/(string: project)/(string: component)/repository/¶
Returns information about the VCS repository status.
The response is same as for
GET /api/projects/(string:project)/repository/.- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
- Response JSON Object:
needs_commit (boolean) – whether there are any pending changes to commit
needs_merge (boolean) – whether there are any upstream changes to merge
needs_push (boolean) – whether there are any local changes to push
remote_commit (string) – Remote commit information
status (string) – VCS repository status as reported by VCS
merge_failure – Text describing merge failure or null if there is none
- POST /api/components/(string: project)/(string: component)/repository/¶
Performs the given operation on a VCS repository.
See
POST /api/projects/(string:project)/repository/for documentation.- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
- Request JSON Object:
operation (string) – Operation to perform: one of
push,pull,commit,reset,cleanup
- Response JSON Object:
result (boolean) – result of the operation
Exemplo de CURL:
curl \ -d operation=pull \ -H "Authorization: Token TOKEN" \ http://example.com/api/components/hello/weblate/repository/
Exemplo de solicitação JSON:
POST /api/components/hello/weblate/repository/ HTTP/1.1 Host: example.com Accept: application/json Content-Type: application/json Authorization: Token TOKEN Content-Length: 20 {"operation":"pull"}
JSON response example:
HTTP/1.0 200 OK Date: Tue, 12 Apr 2016 09:32:50 GMT Server: WSGIServer/0.1 Python/2.7.11+ Vary: Accept, Accept-Language, Cookie X-Frame-Options: SAMEORIGIN Content-Type: application/json Content-Language: en Allow: GET, POST, HEAD, OPTIONS {"result":true}
- GET /api/components/(string: project)/(string: component)/monolingual_base/¶
Downloads base file for monolingual translations.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
- GET /api/components/(string: project)/(string: component)/new_template/¶
Downloads template file for new translations.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
- GET /api/components/(string: project)/(string: component)/translations/¶
Returns a list of translation objects in the given component.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
- Response JSON Object:
results (array) – array of translation objects; see
GET /api/translations/(string:project)/(string:component)/(string:language)/
- POST /api/components/(string: project)/(string: component)/translations/¶
Creates new translation in the given component.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
- Request JSON Object:
language_code (string) – translation language code; see
GET /api/languages/(string:language)/from_component (array) – optional ordered list of source component references used for automatic translation. Accepts numeric component IDs or full Weblate component paths. For form submissions this field can be provided multiple times.
- Response JSON Object:
result (object) – new translation object created
Exemplo de CURL:
curl \ -d language_code=cs \ -H "Authorization: Token TOKEN" \ http://example.com/api/projects/hello/components/
Exemplo de solicitação JSON:
POST /api/projects/hello/components/ HTTP/1.1 Host: example.com Accept: application/json Content-Type: application/json Authorization: Token TOKEN Content-Length: 20 { "language_code": "cs", "from_component": ["hello/weblate", 123] }
JSON response example:
HTTP/1.0 200 OK Date: Tue, 12 Apr 2016 09:32:50 GMT Server: WSGIServer/0.1 Python/2.7.11+ Vary: Accept, Accept-Language, Cookie X-Frame-Options: SAMEORIGIN Content-Type: application/json Content-Language: en Allow: GET, POST, HEAD, OPTIONS { "failing_checks": 0, "failing_checks_percent": 0, "failing_checks_words": 0, "filename": "po/cs.po", "fuzzy": 0, "fuzzy_percent": 0.0, "fuzzy_words": 0, "have_comment": 0, "have_suggestion": 0, "is_template": false, "is_source": false, "language": { "code": "cs", "direction": "ltr", "population": 1303174280 "name": "Czech", "url": "http://example.com/api/languages/cs/", "web_url": "http://example.com/languages/cs/" }, "language_code": "cs", "id": 125, "last_author": null, "last_change": null, "share_url": "http://example.com/engage/hello/cs/", "total": 4, "total_words": 15, "translate_url": "http://example.com/translate/hello/weblate/cs/", "translated": 0, "translated_percent": 0.0, "translated_words": 0, "url": "http://example.com/api/translations/hello/weblate/cs/", "web_url": "http://example.com/projects/hello/weblate/cs/" }
- GET /api/components/(string: project)/(string: component)/statistics/¶
Returns paginated statistics for all translations within component.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
Ver também
Returned attributes are described in Estatísticas.
- GET /api/components/(string: project)/(string: component)/links/¶
Returns projects linked with a component.
Adicionado na versão 4.5.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
- Response JSON Object:
projects (array) – associated projects; see
GET /api/projects/(string:project)/
- POST /api/components/(string: project)/(string: component)/links/¶
Associate project with a component.
Adicionado na versão 4.5.
Alterado na versão 5.17.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
- Form Parameters:
string project_slug – Slug da URL do projeto
int category_id – Category ID in the target project (optional). The category must belong to the specified project.
- DELETE /api/components/(string: project)/(string: component)/links/(string: project_slug)/¶
Remove association of a project with a component.
Adicionado na versão 4.5.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
project_slug (string) – Slug of the project to remove
- GET /api/components/(string: project)/(string: component)/credits/¶
Returns contributor credits for a project.
Adicionado na versão 5.7.
- Parâmetros:
project (string) – Project URL slug
start (date) – Lower-bound ISO 8601 timestamp (mandatory)
end (date) – Upper-bound ISO 8601 timestamp (mandatory)
lang (source_language) – Language code to search for
- Response JSON Object:
email (string) – Email of the contributor
full_name (string) – Full name of the contributor
change_count (string) – Number of changes done in the time range
- GET /api/components/(string: project)/(string: component)/announcements/¶
Adicionado na versão 5.17: Returns announcements for a component.
- param project:
Project URL slug
- type project:
string
- param component:
Component URL slug
- type component:
string
- >json int id:
ID of the announcement
- >json string message:
announcement text
- >json string severity:
color of the message, one of
info(light blue),warning(yellow),danger(red),success(green)- >json date expiry:
hide after this date, ISO 8601 extended format date (optional)
- >json bool notify:
send notification to subscribed users? (optional)
- POST /api/components/(string: project)/(string: component)/announcements/¶
Adicionado na versão 5.17: Creates an announcement for a component.
- param project:
Project URL slug
- type project:
string
- param component:
Component URL slug
- type component:
string
- <json string message:
announcement text
- <json string severity:
color of the message, one of
info(light blue),warning(yellow),danger(red),success(green)- <json date expiry:
hide after this date, ISO 8601 extended format date (optional)
- <json bool notify:
send notification to subscribed users? (optional)
- DELETE /api/components/(string: project)/(string: component)/announcements/(int: announcement_id)/¶
Adicionado na versão 5.17: Deletes an announcement from a component.
- param project:
Project URL slug
- type project:
string
- param component:
Component URL slug
- type component:
string
- param announcement_id:
ID of the announcement to delete
- type announcement_id:
integer
Traduções¶
- GET /api/translations/¶
Returns a list of translations.
Ver também
Translation object attributes are documented at
GET /api/translations/(string:project)/(string:component)/(string:language)/.
- GET /api/translations/(string: project)/(string: component)/(string: language)/¶
Returns information about the translation.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
language (string) – Código de idioma de tradução
- Response JSON Object:
component (object) – component object; see
GET /api/components/(string:project)/(string:component)/failing_checks (int) – number of strings failing checks
failing_checks_percent (float) – percentage of strings failing checks
failing_checks_words (int) – number of words with failing checks
filename (string) – translation filename
fuzzy (int) – number of fuzzy (marked for edit) strings
fuzzy_percent (float) – percentage of fuzzy (marked for edit) strings
fuzzy_words (int) – number of words in fuzzy (marked for edit) strings
have_comment (int) – number of strings with comment
have_suggestion (int) – number of strings with suggestion
is_template (boolean) – whether the translation has a monolingual base
language (object) – source language object; see
GET /api/languages/(string:language)/language_code (string) – language code used in the repository; this can be different from language code in the language object
last_author (string) – name of last author
last_change (timestamp) – last change timestamp
revision (string) – revision hash for the file
share_url (string) – URL for sharing leading to engagement page
total (int) – total number of strings
total_words (int) – total number of words
translate_url (string) – URL for translating
translated (int) – number of translated strings
translated_percent (float) – percentage of translated strings
translated_words (int) – number of translated words
repository_url (string) – URL to repository status; see
GET /api/translations/(string:project)/(string:component)/(string:language)/repository/file_url (string) – URL to file object; see
GET /api/translations/(string:project)/(string:component)/(string:language)/file/changes_list_url (string) – URL to changes list; see
GET /api/translations/(string:project)/(string:component)/(string:language)/changes/units_list_url (string) – URL to strings list; see
GET /api/translations/(string:project)/(string:component)/(string:language)/units/announcements_url (string) – URL to announcements; see
GET /api/translations/(string:project)/(string:component)/(string:language)/announcements/
Example JSON data:
{ "component": { "branch": "main", "file_format": "po", "file_format_params": { "po_line_wrap": 65535, "po_no_location": true }, "filemask": "po/*.po", "git_export": "", "license": "", "license_url": "", "name": "Weblate", "new_base": "", "project": { "name": "Hello", "slug": "hello", "source_language": { "code": "en", "direction": "ltr", "population": 159034349015, "name": "English", "url": "http://example.com/api/languages/en/", "web_url": "http://example.com/languages/en/" }, "url": "http://example.com/api/projects/hello/", "web": "https://weblate.org/", "web_url": "http://example.com/projects/hello/" }, "repo": "file:///home/nijel/work/weblate-hello", "slug": "weblate", "template": "", "url": "http://example.com/api/components/hello/weblate/", "vcs": "git", "web_url": "http://example.com/projects/hello/weblate/" }, "failing_checks": 3, "failing_checks_percent": 75.0, "failing_checks_words": 11, "filename": "po/cs.po", "fuzzy": 0, "fuzzy_percent": 0.0, "fuzzy_words": 0, "have_comment": 0, "have_suggestion": 0, "is_template": false, "language": { "code": "cs", "direction": "ltr", "population": 1303174280 "name": "Czech", "url": "http://example.com/api/languages/cs/", "web_url": "http://example.com/languages/cs/" }, "language_code": "cs", "last_author": "Weblate Admin", "last_change": "2016-03-07T10:20:05.499", "revision": "7ddfafe6daaf57fc8654cc852ea6be212b015792", "share_url": "http://example.com/engage/hello/cs/", "total": 4, "total_words": 15, "translate_url": "http://example.com/translate/hello/weblate/cs/", "translated": 4, "translated_percent": 100.0, "translated_words": 15, "url": "http://example.com/api/translations/hello/weblate/cs/", "web_url": "http://example.com/projects/hello/weblate/cs/" }
- DELETE /api/translations/(string: project)/(string: component)/(string: language)/¶
Deletes a translation.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
language (string) – Código de idioma de tradução
- GET /api/translations/(string: project)/(string: component)/(string: language)/changes/¶
Returns a list of translation changes. This is essentially a translations-scoped
GET /api/changes/accepting the same parameters.- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
language (string) – Código de idioma de tradução
- Response JSON Object:
results (array) – array of component objects; see
GET /api/changes/(int:id)/
- GET /api/translations/(string: project)/(string: component)/(string: language)/units/¶
Returns a list of translation units.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
language (string) – Código de idioma de tradução
q (string) – Search query string Buscas (optional)
- Response JSON Object:
results (array) – array of component objects; see
GET /api/units/(int:id)/
- POST /api/translations/(string: project)/(string: component)/(string: language)/units/¶
Add new unit.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
language (string) – Código de idioma de tradução
- Request JSON Object:
key (string) – Monolingual translations: Key of translation unit
value (array) – Monolingual translations: Source strings (use single string if not creating plural)
context (string) – Bilingual translations: Context of a translation unit
source (array) – Bilingual translations: Source strings (use single string if not creating plural)
target (array) – Bilingual translations: Target strings (use single string if not creating plural)
state (int) – String state; see
GET /api/units/(int:id)/
- Response JSON Object:
unit (object) – newly created unit; see
GET /api/units/(int:id)/
Ver também
- POST /api/translations/(string: project)/(string: component)/(string: language)/autotranslate/¶
Alterado na versão 5.13: The
filter_typeparameter is no longer supported and filtering is done by theqparameter.Trigger automatic translation.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
language (string) – Código de idioma de tradução
- Request JSON Object:
mode (string) – Modo de tradução automática
q (string) – Automatic translation search string, see Buscando textos.
auto_source (string) – Automatic translation source -
mtorotherscomponent (string) – Turn on contribution to shared translation memory for the project to get access to additional components.
engines (array) – Mecanismos para tradução automática
threshold (string) – Limite de pontuação
- GET /api/translations/(string: project)/(string: component)/(string: language)/file/¶
Download current translation file as it is stored in the VCS (without the
formatparameter) or converted to another format (see Baixando traduções).Nota
This API endpoint uses different logic for output than rest of API as it operates on whole file rather than on data. Set of accepted
formatparameter differs and without such parameter you get translation file as stored in VCS.- Response Headers:
Last-Modified – Timestamp of last change to this file.
- Request Headers:
If-Modified-Since – Skips response if the file has not been modified since that time.
- Query Parameters:
format – File format to use; if not specified no format conversion happens; see Baixando traduções for supported formats
q (string) – Filter downloaded strings, see Página de Busca, only applicable when conversion is in place (
formatis specified).
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
language (string) – Código de idioma de tradução
- POST /api/translations/(string: project)/(string: component)/(string: language)/file/¶
Upload new file with translations.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
language (string) – Código de idioma de tradução
- Form Parameters:
string conflicts – How to deal with conflicts (
ignore,replace-translatedorreplace-approved), see Gestão de conflitosfile file – Uploaded file
string author_email – Author e-mail
string author_name – Author name
string method – Upload method (
translate,approve,suggest,fuzzy,replace,source,add), see Métodos de importaçãostring fuzzy – Processamento de textos aproximados (marcados para edição) (vazio,
process,approve)
Exemplo de CURL:
curl -X POST \ -F file=@strings.xml \ -H "Authorization: Token TOKEN" \ http://example.com/api/translations/hello/android/cs/file/
- GET /api/translations/(string: project)/(string: component)/(string: language)/repository/¶
Returns information about the VCS repository status.
The response is same as for
GET /api/components/(string:project)/(string:component)/repository/.- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
language (string) – Código de idioma de tradução
- POST /api/translations/(string: project)/(string: component)/(string: language)/repository/¶
Performs given operation on the VCS repository.
See
POST /api/projects/(string:project)/repository/for documentation.- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
language (string) – Código de idioma de tradução
- Request JSON Object:
operation (string) – Operation to perform: one of
push,pull,commit,reset,cleanup
- Response JSON Object:
result (boolean) – result of the operation
- GET /api/translations/(string: project)/(string: component)/(string: language)/statistics/¶
Returns detailed translation statistics.
- Parâmetros:
project (string) – Project URL slug
component (string) – Component URL slug
language (string) – Código de idioma de tradução
Ver também
Returned attributes are described in Estatísticas.
- GET /api/translations/(string: project)/(string: component)/(string: language)/announcements/¶
Adicionado na versão 5.17: Returns announcements for a translation.
- param project:
Project URL slug
- type project:
string
- param component:
Component URL slug
- type component:
string
- param language:
Código de idioma de tradução
- type language:
string
- >json int id:
ID of the announcement
- >json string message:
announcement text
- >json string severity:
color of the message, one of
info(light blue),warning(yellow),danger(red),success(green)- >json date expiry:
hide after this date, ISO 8601 extended format date (optional)
- >json bool notify:
send notification to subscribed users? (optional)
- POST /api/translations/(string: project)/(string: component)/(string: language)/announcements/¶
Adicionado na versão 5.17: Creates an announcement for a translation.
- param project:
Project URL slug
- type project:
string
- param component:
Component URL slug
- type component:
string
- param language:
Código de idioma de tradução
- type language:
string
- <json string message:
announcement text
- <json string severity:
color of the message, one of
info(light blue),warning(yellow),danger(red),success(green)- <json date expiry:
hide after this date, ISO 8601 extended format date (optional)
- <json bool notify:
send notification to subscribed users? (optional)
- DELETE /api/translations/(string: project)/(string: component)/(string: language)/announcements/(int: announcement_id)/¶
Adicionado na versão 5.17: Deletes an announcement from a translation.
- param project:
Project URL slug
- type project:
string
- param component:
Component URL slug
- type component:
string
- param language:
Código de idioma de tradução
- type language:
string
- param announcement_id:
ID of the announcement to delete
- type announcement_id:
integer
Memória¶
Adicionado na versão 4.14.
- GET /api/memory/¶
Returns a list of memory results.
- Query Parameters:
source – Case-insensitive substring filter on source text (optional)
source_language – Source language code filter (optional)
target_language – Target language code filter (optional)
project – Project slug filter (optional)
- POST /api/memory/lookup/¶
Looks up translation memory matches for the provided source strings.
- Query Parameters:
source_language – Source language code
target_language – Target language code
project – Project slug filter (optional)
exact – Return exact matches only and skip fuzzy matching (optional)
- Request JSON Object:
strings (array) – List of source strings to look up
- Response JSON Object:
results (array) – Ordered lookup results with the best match for each query or
nullwhen no match was found
- DELETE /api/memory/(int: memory_object_id)/¶
Deletes a memory object
- Parâmetros:
memory_object_id – Memory Object ID
Unidades¶
Uma unidade é uma única parte de uma tradução que forma o par de um texto fonte com um texto traduzido correspondente e também contém alguns metadados relacionados. O termo é derivado do translate.storage.base.TranslationUnit no Translate Toolkit e XLIFF.
- GET /api/units/¶
Returns a list of translation units.
- Parâmetros:
q (string) – Search query string Buscas (optional)
Ver também
Unit object attributes are documented at
GET /api/units/(int:id)/.
- GET /api/units/(int: id)/¶
Alterado na versão 4.3: The
targetandsourceare now arrays to properly handle plural strings.Alterado na versão 5.6: The
last_updatedattribute is now exposed.Returns information about the translation unit.
- Parâmetros:
id (int) – Unit ID
- Response JSON Object:
translation (string) – URL of a related translation object
source (array) – source string
previous_source (string) – previous source string used for fuzzy matching
target (array) – target string
id_hash (string) – unique identifier of the unit
content_hash (string) – unique identifier of the source string
location (string) – location of the unit in source code
context (string) – translation unit context
note (string) – translation unit note
flags (string) – translation unit flags
labels (array) – translation unit labels, available on source units
state (int) – unit state, 0 - untranslated, 10 - needs editing, 20 - translated, 30 - approved, 100 - read-only
fuzzy (boolean) – whether the unit is fuzzy or marked for review
translated (boolean) – whether the unit is translated
approved (boolean) – whether the translation is approved
position (int) – unit position in translation file
has_suggestion (boolean) – whether the unit has suggestions
has_comment (boolean) – whether the unit has comments
has_failing_check (boolean) – whether the unit has failing checks
num_words (int) – number of source words
priority (int) – translation priority; 100 is default
id (int) – unit identifier
explanation (string) – String explanation, available on source units, see Informações adicionais sobre textos fonte
extra_flags (string) – Additional string flags, available on source units, see Personalizando comportamento usando marcadores
web_url (string) – URL where the unit can be edited
source_unit (string) – Source unit link; see
GET /api/units/(int:id)/pending (boolean) – whether the unit is pending for write
timestamp (timestamp) – string age
last_updated (timestamp) – last string update
- PATCH /api/units/(int: id)/¶
Adicionado na versão 4.3.
Performs partial update on translation unit.
- Parâmetros:
id (int) – Unit ID
- Request JSON Object:
state (int) – unit state, 0 - untranslated, 10 - needs editing, 20 - translated, 30 - approved (need review workflow enabled, see Revisores dedicados)
target (array) – target string
explanation (string) – String explanation, available on source units, see Informações adicionais sobre textos fonte
extra_flags (string) – Additional string flags, available on source units, see Personalizando comportamento usando marcadores
labels (array) – labels, available on source units
- PUT /api/units/(int: id)/¶
Adicionado na versão 4.3.
Performs full update on translation unit.
- Parâmetros:
id (int) – Unit ID
- Request JSON Object:
state (int) – unit state, 0 - untranslated, 10 - needs editing, 20 - translated, 30 - approved (need review workflow enabled, see Revisores dedicados)
target (array) – target string
explanation (string) – String explanation, available on source units, see Informações adicionais sobre textos fonte
extra_flags (string) – Additional string flags, available on source units, see Personalizando comportamento usando marcadores
labels (array) – labels, available on source units
- DELETE /api/units/(int: id)/¶
Adicionado na versão 4.3.
Deletes a translation unit.
- Parâmetros:
id (int) – Unit ID
- GET /api/units/(int: id)/translations/¶
Adicionado na versão 5.11.
Returns a list of all target translation units for the given source translation unit.
- POST /api/units/(int: id)/comments/¶
Adicionado na versão 5.12.
Create a new comment on the given translation unit.
- Parâmetros:
id (int) – Unit ID
- Request JSON Object:
scope (string) – comment scope - global, translation (available on all non-source units), report (need review workflow enabled, see Revisores dedicados)
comment (string) – content of the new comment, you can use Markdown and mention users by @username.
user_email (string) – commenter’s email, can be set only by project admins and defaults to the authenticated user.
timestamp (string) – creation timestamp of the comment, can be set only by project admins and defaults to now.
- Response JSON Object:
id (int) – comment identifier
comment (string) – content of the new comment
user (string) – URL of the commenter’s object
timestamp (string) – creation timestamp of the comment
- GET /api/units/(int: id)/comments/¶
Adicionado na versão 5.15.
Returns a list of comments on a given translation unit
- Parâmetros:
id (int) – Unit ID
- Response JSON Object:
id (int) – comment identifier
comment (string) – content of the comment
timestamp (string) – creation timestamp of the comment
user (string) – URL of the commenter’s object
Alterações¶
- GET /api/changes/¶
Alterado na versão 4.1: Filtering of changes was introduced in the 4.1 release.
Returns a list of translation changes.
Ver também
Change object attributes are documented at
GET /api/changes/(int:id)/.- Query Parameters:
user (string) – Username of the user to filter by
action (int) – Action to filter, can be used several times
timestamp_after (timestamp) – ISO 8601 formatted timestamp to list changes after
timestamp_before (timestamp) – ISO 8601 formatted timestamp to list changes before
- GET /api/changes/(int: id)/¶
Returns information about the translation change.
- Parâmetros:
id (int) – Change ID
- Response JSON Object:
unit (string) – URL of a related unit object
translation (string) – URL of a related translation object
component (string) – URL of a related component object
user (string) – URL of a related user object
author (string) – URL of a related author object
timestamp (timestamp) – event timestamp
action (int) – numeric identification of action
action_name (string) – text description of action
target (string) – event changed text
old (string) – previous text
details (object) – additional details about the change
id (int) – change identifier
Capturas de tela¶
- GET /api/screenshots/¶
Returns a list of screenshots.
Ver também
Screenshot object attributes are documented at
GET /api/screenshots/(int:id)/.
- GET /api/screenshots/(int: id)/¶
Returns information about the screenshot.
- Parâmetros:
id (int) – Screenshot ID
- Response JSON Object:
name (string) – name of a screenshot
repository_filename (string) – repository path used to match repository-based screenshot updates
translation (string) – URL of a related translation object
file_url (string) – URL to download a file; see
GET /api/screenshots/(int:id)/file/units (array) – link to associated source string information; see
GET /api/units/(int:id)/
- GET /api/screenshots/(int: id)/file/¶
Download the screenshot image.
- Parâmetros:
id (int) – Screenshot ID
- POST /api/screenshots/(int: id)/file/¶
Replace screenshot image.
- Parâmetros:
id (int) – Screenshot ID
- Form Parameters:
file image – Uploaded file
Exemplo de CURL:
curl -X POST \ -F image=@image.png \ -H "Authorization: Token TOKEN" \ http://example.com/api/screenshots/1/file/
- POST /api/screenshots/(int: id)/units/¶
Associate source string with screenshot.
- Parâmetros:
id (int) – Screenshot ID
- Form Parameters:
string unit_id – Unit ID
- Response JSON Object:
name (string) – name of a screenshot
translation (string) – URL of a related translation object
file_url (string) – URL to download a file; see
GET /api/screenshots/(int:id)/file/units (array) – link to associated source string information; see
GET /api/units/(int:id)/
- DELETE /api/screenshots/(int: id)/units/(int: unit_id)¶
Remove source string association with screenshot.
- Parâmetros:
id (int) – Screenshot ID
unit_id – Source string unit ID
- POST /api/screenshots/¶
Creates a new screenshot.
- Form Parameters:
file image – Uploaded file
string name – Screenshot name
string project_slug – Slug da URL do projeto
string component_slug – Slug do componente
string language_code – Código do idioma
string repository_filename – Optional repository path used to associate later repository updates
- Response JSON Object:
name (string) – name of a screenshot
repository_filename (string) – repository path used to match repository-based screenshot updates
translation (string) – URL of a related translation object
file_url (string) – URL to download a file; see
GET /api/screenshots/(int:id)/file/units (array) – link to associated source string information; see
GET /api/units/(int:id)/
- PATCH /api/screenshots/(int: id)/¶
Edit partial information about screenshot.
- Parâmetros:
id (int) – Screenshot ID
- Response JSON Object:
name (string) – name of a screenshot
repository_filename (string) – repository path used to match repository-based screenshot updates
translation (string) – URL of a related translation object
file_url (string) – URL to download a file; see
GET /api/screenshots/(int:id)/file/units (array) – link to associated source string information; see
GET /api/units/(int:id)/
- PUT /api/screenshots/(int: id)/¶
Edit full information about screenshot.
- Parâmetros:
id (int) – Screenshot ID
- Response JSON Object:
name (string) – name of a screenshot
repository_filename (string) – repository path used to match repository-based screenshot updates
translation (string) – URL of a related translation object
file_url (string) – URL to download a file; see
GET /api/screenshots/(int:id)/file/units (array) – link to associated source string information; see
GET /api/units/(int:id)/
- DELETE /api/screenshots/(int: id)/¶
Delete screenshot.
- Parâmetros:
id (int) – Screenshot ID
Complementos¶
Adicionado na versão 4.4.1.
- GET /api/addons/¶
Returns a list of add-ons.
Ver também
Add-on object attributes are documented at
GET /api/addons/(int:id)/.
- GET /api/addons/(int: id)/¶
Returns information about add-on information.
- Parâmetros:
id (int) – ID do complemento
- Response JSON Object:
name (string) – name of an add-on
component (string) – URL of a related component object
configuration (object) – Optional add-on configuration
Ver também
- POST /api/components/(string: project)/(string: component)/addons/¶
Creates a new add-on.
- Parâmetros:
project_slug (string) – Slug da URL do projeto
component_slug (string) – Slug do componente
- Request JSON Object:
name (string) – name of an add-on
configuration (object) – Optional add-on configuration
- PATCH /api/addons/(int: id)/¶
Edit partial information about add-on.
- Parâmetros:
id (int) – ID do complemento
- Response JSON Object:
configuration (object) – Optional add-on configuration
- PUT /api/addons/(int: id)/¶
Edit full information about add-on.
- Parâmetros:
id (int) – ID do complemento
- Response JSON Object:
configuration (object) – Optional add-on configuration
- DELETE /api/addons/(int: id)/¶
Delete add-on.
- Parâmetros:
id (int) – ID do complemento
- POST /api/addons/(int: id)/trigger/¶
Trigger a manual run of an add-on that supports manual triggering.
Adicionado na versão 5.17.1.
- Parâmetros:
id (int) – ID do complemento
Listas de componentes¶
Adicionado na versão 4.0.
- GET /api/component-lists/¶
Returns a list of component lists.
Ver também
Component list object attributes are documented at
GET /api/component-lists/(str:slug)/.
- GET /api/component-lists/(str: slug)/¶
Returns information about component list.
- Parâmetros:
slug (string) – Component list slug
- Response JSON Object:
name (string) – name of a component list
slug (string) – slug of a component list
show_dashboard (boolean) – whether to show it on a dashboard
components (array) – link to associated components; see
GET /api/components/(string:project)/(string:component)/auto_assign (array) – automatic assignment rules
- PUT /api/component-lists/(str: slug)/¶
Changes the component list parameters.
- Parâmetros:
slug (string) – Component list slug
- Request JSON Object:
name (string) – name of a component list
slug (string) – slug of a component list
show_dashboard (boolean) – whether to show it on a dashboard
- PATCH /api/component-lists/(str: slug)/¶
Changes the component list parameters.
- Parâmetros:
slug (string) – Component list slug
- Request JSON Object:
name (string) – name of a component list
slug (string) – slug of a component list
show_dashboard (boolean) – whether to show it on a dashboard
- DELETE /api/component-lists/(str: slug)/¶
Deletes the component list.
- Parâmetros:
slug (string) – Component list slug
- GET /api/component-lists/(str: slug)/components/¶
Adicionado na versão 5.0.1: List components in a component list.
- param slug:
Component list slug
- type slug:
string
- form string component_id:
Component ID
- >json array results:
array of component objects; see
GET /api/components/(string:project)/(string:component)/
- POST /api/component-lists/(str: slug)/components/¶
Associate component with a component list.
- Parâmetros:
slug (string) – Component list slug
- Form Parameters:
string component_id – Component ID
- DELETE /api/component-lists/(str: slug)/components/(str: component_slug)¶
Disassociate a component from the component list.
- Parâmetros:
slug (string) – Component list slug
component_slug (string) – Slug do componente
Glossário¶
Alterado na versão 4.5: Glossários agora são armazenados como componentes, traduções e textos comuns. Use a respectiva API.
Tarefas¶
Adicionado na versão 4.4.
- GET /api/tasks/¶
Listing of the tasks is currently not available.
- GET /api/tasks/(str: uuid)/¶
Returns information about a task.
- Parâmetros:
uuid (string) – Task UUID
- Response JSON Object:
completed (boolean) – Whether the task has completed
progress (int) – Task progress in percent
result (object) – Task result or progress details
log (string) – Task log
Estatísticas¶
- GET /api/(str: object)/statistics/¶
There are several statistics endpoints for objects and all of them contain same structure.
- Parâmetros:
object (string) – URL path
- Response JSON Object:
total (int) – total number of strings
total_words (int) – total number of words
total_chars (int) – total number of characters
last_change (timestamp) – date of last change
translated (int) – number of translated strings
translated_percent (float) – percentage of translated strings
translated_words (int) – number of translated words
translated_words_percent (float) – percentage of translated words
translated_chars (int) – number of translated characters
translated_chars_percent (float) – percentage of translated characters
fuzzy (int) – number of fuzzy (marked for edit) strings
fuzzy_words (int) – number of fuzzy (marked for edit) words
fuzzy_chars (int) – number of fuzzy (marked for edit) characters
fuzzy_percent (float) – percentage of fuzzy (marked for edit) strings
fuzzy_words_percent (float) – percentage of fuzzy (marked for edit) words
fuzzy_chars_percent (float) – percentage of fuzzy (marked for edit) characters
failing (int) – number of failing checks
failing_percent (float) – percentage of failing checks
approved (int) – number of approved strings
approved_words (int) – number of approved words
approved_chars (int) – number of approved characters
approved_percent (float) – percentage of approved strings
approved_words_percent (float) – percentage of approved words
approved_chars_percent (float) – percentage of approved characters
readonly (int) – number of read-only strings
readonly_words (int) – number of read-only words
readonly – number of read-only characters
readonly_percent (float) – percentage of read-only strings
readonly_words_percent (float) – percentage of read-only words
readonly_char_percent (float) – percentage of read-only characters
suggestions (int) – number of strings with suggestions
comments (int) – number of strings with comments
name (string) – object name
url (string) – URL to access the object (if applicable)
url_translate (string) – URL to access the translation (if applicable)
code (string) – language code (if applicable)
Ver também
Métricas¶
- GET /api/metrics/¶
Returns server metrics.
Alterado na versão 5.6.1: Metrics can now be exposed in OpenMetrics compatible format with
?format=openmetrics.- Response JSON Object:
units (int) – Number of units
units_translated (int) – Number of translated units
users (int) – Number of users
changes (int) – Number of changes
projects (int) – Number of projects
components (int) – Number of components
translations (int) – Number of translations
languages (int) – Number of used languages
checks (int) – Number of triggered quality checks
configuration_errors (int) – Number of configuration errors
suggestions (int) – Number of pending suggestions
celery_queues (object) – Lengths of Celery queues, see Tarefas de fundo usando Celery
name (string) – Configured server name
version (string) – Running Weblate version, included when
VERSION_DISPLAYisshoworsoft
In OpenMetrics format, the version is exposed as
weblate_info{version="..."} 1whenVERSION_DISPLAYisshoworsoft.
Buscar¶
- GET /api/search/¶
Adicionado na versão 4.18.
Returns site-wide search results as a list. There is no pagination on the result set, only first few matches are returned for each category.
The search looks for:
Projetos
Categorias
Componentes
Idiomas
Usuários
- Parâmetros:
q – Search query string
- Response JSON Object:
name (str) – Name of the matched item.
url (str) – Web URL of the matched item.
category (str) – Category of the matched item.
Categorias¶
- GET /api/categories/¶
Adicionado na versão 5.0.
Lists available categories. See
GET /api/categories/(int:id)/for field definitions.
- POST /api/categories/¶
Adicionado na versão 5.0.
Creates a new category. See
GET /api/categories/(int:id)/for field definitions.
- GET /api/categories/(int: id)/¶
Adicionado na versão 5.0.
- Parâmetros:
id (int) – Category ID
- Response JSON Object:
name (str) – Name of category.
slug (str) – Slug of category.
project (str) – Link to a project.
category (str) – Link to a parent category.
announcements_url (string) – URL to announcements; see
GET /api/categories/(int:id)/announcements/
- PATCH /api/categories/(int: id)/¶
Adicionado na versão 5.0: Edit partial information about category.
- param id:
Category ID
- type id:
int
- >json object configuration:
Optional category configuration
- PUT /api/categories/(int: id)/¶
Adicionado na versão 5.0: Edit full information about category.
- param id:
Category ID
- type id:
int
- >json object configuration:
Optional category configuration
- DELETE /api/categories/(int: id)/¶
Adicionado na versão 5.0: Delete category.
- param id:
Category ID
- type id:
int
- GET /api/categories/(int: id)/statistics/¶
Adicionado na versão 5.5.
Returns statistics for a category.
- Parâmetros:
id (int) – Category ID
Ver também
Returned attributes are described in Estatísticas.
- GET /api/categories/(int: id)/announcements/¶
Adicionado na versão 5.17.1: Returns announcements for a category.
- param id:
Category ID
- type id:
int
- >json int id:
ID of the announcement
- >json string message:
announcement text
- >json string severity:
color of the message, one of
info(light blue),warning(yellow),danger(red),success(green)- >json date expiry:
hide after this date, ISO 8601 extended format date (optional)
- >json bool notify:
send notification to subscribed users? (optional)
- POST /api/categories/(int: id)/announcements/¶
Adicionado na versão 5.17.1: Creates an announcement for a category.
- param id:
Category ID
- type id:
int
- <json string message:
announcement text
- <json string severity:
color of the message, one of
info(light blue),warning(yellow),danger(red),success(green)- <json date expiry:
hide after this date, ISO 8601 extended format date (optional)
- <json bool notify:
send notification to subscribed users? (optional)
- DELETE /api/categories/(int: id)/announcements/(int: announcement_id)/¶
Adicionado na versão 5.17.1: Deletes an announcement from a category.
- param id:
Category ID
- type id:
int
- param announcement_id:
ID of the announcement to delete
- type announcement_id:
integer
Ganchos de notificação¶
Os ganchos de notificação permitem que aplicativos externos notifiquem o Weblate que o repositório VCS foi atualizado.
Você pode usar terminais de repositório para projetos, componentes e traduções para atualizar repositórios individuais; consulte POST /api/projects/(string:project)/repository/ para a documentação.
- GET /hooks/update/(string: project)/(string: component)/¶
Descontinuado desde a versão 2.6: Please use
POST /api/components/(string:project)/(string:component)/repository/instead which works properly with authentication for ACL limited projects.Removido na versão 5.14.
- GET /hooks/update/(string: project)/¶
Descontinuado desde a versão 2.6: Please use
POST /api/projects/(string:project)/repository/instead which works properly with authentication for ACL limited projects.Removido na versão 5.14.
- POST /hooks/github/¶
Special hook for handling GitHub notifications and automatically updating matching components.
Nota
GitHub includes direct support for notifying Weblate: enable Weblate service hook in repository settings and set the URL to the URL of your Weblate installation.
Ver também
- GitHub notifications
For instruction on setting up GitHub integration
- https://docs.github.com/en/get-started/customizing-your-github-workflow/exploring-integrations/about-webhooks
Generic information about GitHub Webhooks
ENABLE_HOOKSFor enabling hooks for whole Weblate
- POST /hooks/gitlab/¶
Special hook for handling GitLab notifications and automatically updating matching components.
Ver também
- GitLab notifications
For instruction on setting up GitLab integration
- https://docs.gitlab.com/user/project/integrations/webhooks/
Generic information about GitLab Webhooks
ENABLE_HOOKSFor enabling hooks for whole Weblate
- POST /hooks/bitbucket/¶
Special hook for handling Bitbucket notifications and automatically updating matching components.
Ver também
- Bitbucket notifications
For instruction on setting up Bitbucket integration
- https://support.atlassian.com/bitbucket-cloud/docs/manage-webhooks/
Generic information about Bitbucket Webhooks
ENABLE_HOOKSFor enabling hooks for whole Weblate
- POST /hooks/pagure/¶
Special hook for handling Pagure notifications and automatically updating matching components.
Ver também
- Pagure notifications
For instruction on setting up Pagure integration
- https://docs.pagure.org/pagure/usage/using_webhooks.html
Generic information about Pagure Webhooks
ENABLE_HOOKSFor enabling hooks for whole Weblate
- POST /hooks/azure/¶
Special hook for handling Azure DevOps notifications and automatically updating matching components.
Nota
Please ensure that Resource details to send is set to All, otherwise Weblate will not be able to match your Azure repository.
Ver também
- Azure Repos notifications
For instruction on setting up Azure integration
- https://learn.microsoft.com/en-us/azure/devops/service-hooks/services/webhooks?view=azure-devops
Generic information about Azure DevOps Web Hooks
ENABLE_HOOKSFor enabling hooks for whole Weblate
- POST /hooks/gitea/¶
Special hook for handling Gitea Webhook notifications and automatically updating matching components.
Ver também
- Gitea notifications
For instruction on setting up Gitea integration
- https://docs.gitea.io/en-us/webhooks/
Generic information about Gitea Webhooks
ENABLE_HOOKSFor enabling hooks for whole Weblate
- POST /hooks/forgejo/¶
Special hook for handling Forgejo Webhook notifications and automatically updating matching components.
Ver também
- Forgejo notifications
For instruction on setting up Forgejo integration
- https://forgejo.org/docs/latest/user/webhooks/
Generic information about Forgejo Webhooks
ENABLE_HOOKSFor enabling hooks for whole Weblate
- POST /hooks/gitee/¶
Special hook for handling Gitee Webhook notifications and automatically updating matching components.
Ver também
- Gitee notifications
For instruction on setting up Gitee integration
- https://gitee.com/help/categories/40
Generic information about Gitee Webhooks
ENABLE_HOOKSFor enabling hooks for whole Weblate
Feeds RSS¶
As alterações nas traduções são exportadas em feeds RSS.
Filtered RSS feeds are available from the changes browser. These accept the same
filters as the changes page, for example action, user, exclude_user,
and period.
- GET /changes/rss/¶
Retrieves RSS feed with recent changes matching changes browsing filters.
- GET /changes/rss/(string: project)/(string: component)/(string: language)/¶
Retrieves RSS feed with recent changes matching changes browsing filters in a translation.
- GET /changes/rss/(string: project)/(string: component)/¶
Retrieves RSS feed with recent changes matching changes browsing filters in a component.
- GET /changes/rss/(string: project)/-/(string: language)/¶
Retrieves RSS feed with recent changes matching changes browsing filters in a project language.
- GET /changes/rss/-/-/(string: language)/¶
Retrieves RSS feed with recent changes matching changes browsing filters in a language.
- GET /exports/rss/(string: project)/(string: component)/(string: language)/¶
Retrieves RSS feed with recent changes for a translation.
- GET /exports/rss/(string: project)/(string: component)/¶
Retrieves RSS feed with recent changes for a component.
- GET /exports/rss/(string: project)/¶
Retrieves RSS feed with recent changes for a project.
- GET /exports/rss/language/(string: language)/¶
Retrieves RSS feed with recent changes for a language.
- GET /exports/rss/¶
Retrieves RSS feed with recent changes for Weblate instance.
Ver também